SystemOrganization addCategory: #ConfigurationOfSmallchange!

Object subclass: #ConfigurationOfSmallchange
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSmallchange'!

!ConfigurationOfSmallchange class methodsFor: 'development support' stamp: 'StuartHerring 2/12/2012 13:31'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSmallchange class methodsFor: 'private' stamp: 'StuartHerring 2/12/2012 13:31'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSmallchange class methodsFor: 'private' stamp: 'StuartHerring 2/12/2012 13:31'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSmallchange class methodsFor: 'private' stamp: 'StuartHerring 2/12/2012 13:31'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSmallchange class methodsFor: 'metacello tool support' stamp: 'StuartHerring 2/12/2012 13:31'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSmallchange class methodsFor: 'loading' stamp: 'StuartHerring 2/12/2012 13:31'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSmallchange class methodsFor: 'loading' stamp: 'StuartHerring 2/12/2012 13:31'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSmallchange class methodsFor: 'loading' stamp: 'StuartHerring 2/12/2012 13:31'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSmallchange class methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 13:31'!
project

	^self new project! !

!ConfigurationOfSmallchange class methodsFor: 'development support' stamp: 'StuartHerring 2/12/2012 13:31'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSmallchange methodsFor: 'baselines' stamp: 'StuartHerring 2/12/2012 14:01'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.stuartherring.net/mc/Smallchange'.
		spec 
			project: 'Mabinogi' with: [
				spec
					className: 'ConfigurationOfMabinogi';
					versionString: #'bleedingEdge';
					repository: 'http://stuartherring.net/dav/mc/Mabinogi' ];
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					loads: #('Base' 'JQuery-Core') ];
		 	project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'];
			project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'SIXX' with: [
				spec
					className: 'ConfigurationOfSIXX';
					versionString: '0.3.6';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Smallchange-Core' with: [
				spec requires: #('Mabinogi' ). ];
			package: 'Smallchange-Web' with: [
				spec requires: #('Smallchange-Core' 'Seaside30' 'SIXX' ). ];
			package: 'Smallchange-Test' with: [
				spec requires: #('Smallchange-Core' 'Mocketry' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Smallchange-Core' 'Smallchange-Web' );
			group: 'Tests' with: #('Smallchange-Test' );
			group: 'Development' with: #('Core' 'Tests' 'Seaside30 Development' ). ].
! !

!ConfigurationOfSmallchange methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 13:31'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSmallchange methodsFor: 'versions' stamp: 'StuartHerring 2/12/2012 13:53'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: 'initial version'.
		spec author: 'StuartHerring'.
		spec timestamp: '2/12/2012 13:46'.
		spec 
			project: 'Mabinogi' with: '1.0'.
		spec 
			package: 'Smallchange-Core' with: 'Smallchange-Core-StuartHerring.4';
			package: 'Smallchange-Web' with: 'Smallchange-Web-StuartHerring.2';
			package: 'Smallchange-Test' with: 'Smallchange-Test-StuartHerring.2'. ].
! !
